--
-- vogelsangSwingMax30
-- Specialization for vogelsangSwingMax30
--
-- @author monteur1
-- (xmlFile)

vogelsangSwingMax30 = {};

function vogelsangSwingMax30.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(newSprayer, specializations) and
           SpecializationUtil.hasSpecialization(AttacherJoints, specializations);
end;

function vogelsangSwingMax30:load(xmlFile)
    self.groundAdjustRaycastCallback = vogelsangSwingMax30.groundAdjustRaycastCallback;
--    self.getIsInWorkPosition = Utils.overwrittenFunction(self.getIsInWorkPosition, ManureBarrel.getIsInWorkPosition);
--    self.getCanBeTurnedOn = Utils.overwrittenFunction(self.getCanBeTurnedOn, ManureBarrel.getCanBeTurnedOn);
--    self.getIsTurnedOnAllowed = Utils.overwrittenFunction(self.getIsTurnedOnAllowed, ManureBarrel.getIsTurnedOnAllowed);
--    self.setIsTurnedOn = Utils.overwrittenFunction(self.setIsTurnedOn, ManureBarrel.setIsTurnedOn);
--    self.getIsReadyToSpray = Utils.overwrittenFunction(self.getIsReadyToSpray, ManureBarrel.getIsReadyToSpray);
--    self.getAreEffectsVisible = Utils.overwrittenFunction(self.getAreEffectsVisible, ManureBarrel.getAreEffectsVisible);
--    self.getIsWorkAreaActive = Utils.overwrittenFunction(self.getIsWorkAreaActive, ManureBarrel.getIsWorkAreaActive);
    self.manureBarrelFoldMinLimit = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.manureBarrel#foldMinLimit"), 0);
    self.manureBarrelFoldMaxLimit = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.manureBarrel#foldMaxLimit"), 1);
    self.attachToolAnimation = getXMLString(self.xmlFile, "vehicle.manureBarrel#toolAttachAnimName");
    self.attachToolJointIndex = getXMLInt(self.xmlFile, "vehicle.manureBarrel#attacherJointIndex");

	self.workingwidthLeftIDX = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.workingwidthLeft#index"));	
	self.workingwidthRightIDX = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.workingwidthRight#index"));	

	self.outherArmTransIndex = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.outherArmWorkPos#index"));	
	self.outherArmTransPos = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.outherArmWorkPosSettings#pos"), 0);	
	self.outherArmTransTol = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.outherArmWorkPosSettings#tol"), 0);	
	local pos = self.outherArmTransPos
	local tol = self.outherArmTransTol	
    self.armFoldedTrigger = pos + tol
		
    local outherArmMarker = self.outherArmTransIndex		
    local bx,by,bz = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.outherArmWorkPos#index"));
    bx,by,bz = getRotation(outherArmMarker);

    self.groundAdjustedNodes = {};	
    local i = 0;
    while true do
        local key = string.format("vehicle.groundAdjustedNodes.groundAdjustedNode(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local node = Utils.indexToObject(self.components, getXMLString(self.xmlFile, key.."#index"));
        if node ~= nil then
            local x,y,z = getTranslation(node);
            local raycastNodes = {};
            local j = 0;
            while true do
                local raycastKey = key..string.format(".raycastNode(%d)", j);
                if not hasXMLProperty(self.xmlFile, raycastKey) then
                    break;
                end;
                local raycastNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, raycastKey.."#index"));
                if raycastNode ~= nil then
                    assert(getParent(node) == getParent(raycastNode));
                    local _,y1,_ = getTranslation(raycastNode);
                    table.insert(raycastNodes, {node=raycastNode, yDiff=y1-y});
                end;
                j = j+1;
            end;
            if table.getn(raycastNodes) > 0 then
                local minY = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#minY"), y-1);
                local maxY = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#maxY"), minY+1);
                local yOffset = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#yOffset"), 0);
                local moveSpeed = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#moveSpeed"), 1)/1000;
                local adjustedNode = {node=node, raycastNodes=raycastNodes, x=x, y=y, z=z, curY=y, targetY=y, minY=minY, maxY=maxY, yOffset=yOffset, moveSpeed=moveSpeed}
                adjustedNode.foldMinLimit = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#foldMinLimit"), 0);
                adjustedNode.foldMaxLimit = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#foldMaxLimit"), 1);
                local translationNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, key.."#translationNode"));
                if translationNode ~= nil then
                    local tx, ty, tz = getWorldTranslation(translationNode);
                    local tx, ty, tz = worldToLocal(node, tx, ty, tz);
                    adjustedNode.translationNode=translationNode;
                    adjustedNode.tx=tx;
                    adjustedNode.ty=ty;
                    adjustedNode.tz=tz;
                end;
                table.insert(self.groundAdjustedNodes, adjustedNode);
            end;
        end;
        i = i + 1;
    end;
	
    self.groundAdjustedNodes_2 = {};	
    local i = 0;
    while true do
        local key = string.format("vehicle.groundAdjustedNodes_2.groundAdjustedNode_2(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local node = Utils.indexToObject(self.components, getXMLString(self.xmlFile, key.."#index"));
        if node ~= nil then
            local x,y,z = getTranslation(node);
            local raycastNodes = {};
            local j = 0;
            while true do
                local raycastKey = key..string.format(".raycastNode(%d)", j);
                if not hasXMLProperty(self.xmlFile, raycastKey) then
                    break;
                end;
                local raycastNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, raycastKey.."#index"));
                if raycastNode ~= nil then
                    assert(getParent(node) == getParent(raycastNode));
                    local _,y1,_ = getTranslation(raycastNode);
                    table.insert(raycastNodes, {node=raycastNode, yDiff=y1-y});
                end;
                j = j+1;
            end;
            if table.getn(raycastNodes) > 0 then
                local minY = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#minY"), y-1);
                local maxY = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#maxY"), minY+1);
                local yOffset = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#yOffset"), 0);
                local moveSpeed = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#moveSpeed"), 1)/1000;
                local adjustedNode = {node=node, raycastNodes=raycastNodes, x=x, y=y, z=z, curY=y, targetY=y, minY=minY, maxY=maxY, yOffset=yOffset, moveSpeed=moveSpeed}
                adjustedNode.foldMinLimit = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#foldMinLimit"), 0);
                adjustedNode.foldMaxLimit = Utils.getNoNil(getXMLFloat(self.xmlFile, key.."#foldMaxLimit"), 1);
                local translationNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, key.."#translationNode"));
                if translationNode ~= nil then
                    local tx, ty, tz = getWorldTranslation(translationNode);
                    local tx, ty, tz = worldToLocal(node, tx, ty, tz);
                    adjustedNode.translationNode=translationNode;
                    adjustedNode.tx=tx;
                    adjustedNode.ty=ty;
                    adjustedNode.tz=tz;
                end;
                table.insert(self.groundAdjustedNodes_2, adjustedNode);
            end;
        end;
        i = i + 1;
    end;	
end;

function vogelsangSwingMax30:update(dt)
    if self:getIsActive() then
        if self.isClient then
			if self.sectionShiftMainFoldingActive == false and self.sectionShiftMainFolded == false and self.sectionShiftSwingMaxOnTop == false then		
				for _, node in pairs(self.groundAdjustedNodes) do
					if node.targetY ~= node.curY then
						if node.targetY > node.curY then
							node.curY = math.min(node.curY + node.moveSpeed*dt, node.targetY);
						else
							node.curY = math.max(node.curY - node.moveSpeed*dt, node.targetY);
						end;
						setTranslation(node.node, node.x, node.curY, node.z);
						if node.translationNode ~= nil then
							local tx, ty, tz = localToWorld(node.node, node.tx, node.ty, node.tz);
							local tx, ty, tz = worldToLocal(getParent(node.translationNode), tx, ty, tz);
							setTranslation(node.translationNode, tx, ty, tz);
						end;
					end;
				end;
			end;
			
			local gx, gy, gz = getTranslation(self.outherArmTransIndex);
			if gy < self.armFoldedTrigger then
				AktualAktivePipeState = 2
				--self.sectionShiftFoldableSection1aktive = false ;					
			else 
				AktualAktivePipeState = 1
				--self.sectionShiftFoldableSection1aktive = true ;					
			end;

			if AktualAktivePipeState == 2 then						
				if self.sectionShiftFoldableSection1aktive == false and self.sectionShiftMainFoldingActive == false and self.sectionShiftMainFolded == false and self.sectionShiftSwingMaxOnTop == false then						
					for _, node in pairs(self.groundAdjustedNodes_2) do
						if node.targetY ~= node.curY then
							if node.targetY > node.curY then
								node.curY = math.min(node.curY + node.moveSpeed*dt, node.targetY);
							else
								node.curY = math.max(node.curY - node.moveSpeed*dt, node.targetY);
							end;
								setTranslation(node.node, node.x, node.curY, node.z);
							if node.translationNode ~= nil then
								local tx, ty, tz = localToWorld(node.node, node.tx, node.ty, node.tz);
								local tx, ty, tz = worldToLocal(getParent(node.translationNode), tx, ty, tz);
								setTranslation(node.translationNode, tx, ty, tz);
							end;
						end;
					end;
				end;
			end

			local widthLeft
			local widthRight
			
			local wlx, wly, wlz = getTranslation(self.workingwidthLeftIDX);	
			if wlx < 0 then
				widthLeft = -wlx
			else
				widthLeft = wlx			
			end
			local wrx, wry, wrz = getTranslation(self.workingwidthRightIDX);
			if wrx < 0 then
				widthRight = -wrx
			else
				widthRight = wrx
			end

			local sprayUsage = widthRight + widthLeft
		end;
    end;
end;

function vogelsangSwingMax30:updateTick(dt)
    if self:getIsActive() then
        if self.isClient then
            local foldAnimTime = self.foldAnimTime;			
			if self.sectionShiftMainFoldingActive == false and self.sectionShiftMainFolded == false and self.sectionShiftSwingMaxOnTop == false then
				for _, node in pairs(self.groundAdjustedNodes) do
					if foldAnimTime == nil or (foldAnimTime <= node.foldMaxLimit and foldAnimTime >= node.foldMinLimit) then
						local newY = node.minY;
						for _, raycastNode in pairs(node.raycastNodes) do
							local x,y,z = getWorldTranslation(raycastNode.node);
							local dx,dy,dz = localDirectionToWorld(raycastNode.node, 0, -1, 0);
							self.lastRaycastDistance = 0;
							raycastClosest(x, y, z, dx, dy, dz, "groundAdjustRaycastCallback", 4, self);
							if self.lastRaycastDistance ~= 0 then
								newY = math.max(newY, node.y - self.lastRaycastDistance + raycastNode.yDiff - node.yOffset);
							end;
						end;
						newY = Utils.clamp(newY, node.minY, node.maxY);
						node.targetY = newY;
						_, node.curY, _ = getTranslation(node.node);
					end;
				end;
			end
			
			local gx, gy, gz = getTranslation(self.outherArmTransIndex);
			if gy < self.armFoldedTrigger then
				AktualAktivePipeState = 2
				--self.sectionShiftFoldableSection1aktive = true ;					
			else 
				AktualAktivePipeState = 1
				--self.sectionShiftFoldableSection1aktive = false ;					
			end;

			if AktualAktivePipeState == 2 then
				if self.sectionShiftFoldableSection1aktive == false and self.sectionShiftMainFoldingActive == false and self.sectionShiftMainFolded == false and self.sectionShiftSwingMaxOnTop == false then			
					for _, node in pairs(self.groundAdjustedNodes_2) do
						local newY = node.minY;
						for _, raycastNode in pairs(node.raycastNodes) do
							local x,y,z = getWorldTranslation(raycastNode.node);
							local dx,dy,dz = localDirectionToWorld(raycastNode.node, 0, -1, 0);
							self.lastRaycastDistance = 0;
							raycastClosest(x, y, z, dx, dy, dz, "groundAdjustRaycastCallback", 4, self);
							if self.lastRaycastDistance ~= 0 then
								newY = math.max(newY, node.y - self.lastRaycastDistance + raycastNode.yDiff - node.yOffset);
							end;
						end;
						newY = Utils.clamp(newY, node.minY, node.maxY);
						node.targetY = newY;
						_, node.curY, _ = getTranslation(node.node);
					end;
				end
            end;			
        end;
    end;
end;

function vogelsangSwingMax30:draw()
end;

function vogelsangSwingMax30:onAttachImplement(implement)
    local object = implement.object;
    if self.attachToolJointIndex ~= nil and implement.jointDescIndex then
        self.attachedTool = object;
        if self.attachToolAnimation ~= nil and self.playAnimation ~= nil then
            self:playAnimation(self.attachToolAnimation, 1, self:getAnimationTime(self.attachToolAnimation), true);
        end;
        if self.attachedTool.aiLeftMarker ~= nil and self.attachedTool.aiRightMarker ~= nil and self.attachedTool.aiBackMarker ~= nil then
            self.aiLeftMarkerBackup, self.aiRightMarkerBackup, self.aiBackMarkerBackup = self.aiLeftMarker, self.aiRightMarker, self.aiBackMarker;
            self.aiLeftMarker, self.aiRightMarker, self.aiBackMarker = self.attachedTool.aiLeftMarker, self.attachedTool.aiRightMarker, self.attachedTool.aiBackMarker;
            self.attachedTool.aiLeftMarker, self.attachedTool.aiRightMarker, self.attachedTool.aiBackMarker = nil, nil, nil;
            self.terrainDetailRequiredValueRangesBackUp = {};
            for _,range in pairs(self.terrainDetailRequiredValueRanges) do
                table.insert(self.terrainDetailRequiredValueRangesBackUp, {range[1], range[2], range[3], range[4]});
            end
            self.terrainDetailProhibitValueRangesBackUp = {};
            for _,range in pairs(self.terrainDetailProhibitValueRanges) do
                table.insert(self.terrainDetailProhibitValueRangesBackUp, {range[1], range[2], range[3], range[4]});
            end
            self.terrainDetailRequiredValueRanges = self.attachedTool.terrainDetailRequiredValueRanges;
            self.terrainDetailProhibitValueRanges = self.attachedTool.terrainDetailProhibitValueRanges;
        end;
    end;
end;

function vogelsangSwingMax30:onDetachImplement(implementIndex)
    local object = self.attachedImplements[implementIndex].object;
    if object ~= nil then
        if self.attachedImplements[implementIndex].jointDescIndex == self.attachToolJointIndex then
            if self.attachToolAnimation ~= nil and self.playAnimation ~= nil then
                self:playAnimation(self.attachToolAnimation, -1, self:getAnimationTime(self.attachToolAnimation), true);
            end;
            if self.aiLeftMarkerBackup ~= nil and self.aiRightMarkerBackup ~= nil and self.aiBackMarkerBackup ~= nil then
                self.attachedTool.aiLeftMarker, self.attachedTool.aiRightMarker, self.attachedTool.aiBackMarker = self.aiLeftMarker, self.aiRightMarker, self.aiBackMarker;
                self.aiLeftMarker, self.aiRightMarker, self.aiBackMarker = self.aiLeftMarkerBackup, self.aiRightMarkerBackup, self.aiBackMarkerBackup;
                self.terrainDetailRequiredValueRanges = {};
                for _,range in pairs(self.terrainDetailRequiredValueRangesBackUp) do
                    table.insert(self.terrainDetailRequiredValueRanges, {range[1], range[2], range[3], range[4]});
                end
                self.terrainDetailProhibitValueRanges = {};
                for _,range in pairs(self.terrainDetailProhibitValueRangesBackUp) do
                    table.insert(self.terrainDetailProhibitValueRanges, {range[1], range[2], range[3], range[4]});
                end
            end;
            self.attachedTool = nil;
        end;
    end;
end;

function vogelsangSwingMax30:getIsReadyToSpray(superFunc)
    if self.attachedTool ~= nil then
        return false;
    end;
    if superFunc ~= nil then
        superFunc(self);
    end;
    return true;
end;

function vogelsangSwingMax30:getAreEffectsVisible(superFunc)
    if self.attachedTool ~= nil then
        return false;
    end;
    if superFunc ~= nil then
        return superFunc(self);
    end;
    return true;
end;

function vogelsangSwingMax30:getIsWorkAreaActive(superFunc, workArea)
    if self.attachedTool ~= nil then
        return false;
    end;
    if superFunc ~= nil then
        return superFunc(self, workArea);
    end;
    return true;
end;

function vogelsangSwingMax30:getLitersPerSecond(superFunc, fillType)
    if self.attachedTool ~= nil and self.attachedTool.getLitersPerSecond ~= nil then
        return self.attachedTool:getLitersPerSecond(fillType);
    end;
    if superFunc ~= nil then
        return superFunc(self, fillType);
    end;
    return self.defaultSprayLitersPerSecond;
end;

function vogelsangSwingMax30:getIsInWorkPosition()
    if self.attachedTool == nil then
        if foldAnimTime ~= nil and (foldAnimTime > self.manureBarrelFoldMaxLimit or foldAnimTime < self.manureBarrelFoldMinLimit) then
            return false;
        end;
    else
        --return self.attachedTool:getIsInWorkPosition();
        if self.attachedTool:getIsInWorkPosition() then
            local implement = self:getImplementByObject(self.attachedTool);
            if implement ~= nil then
                local jointDesc = self.attacherJoints[implement.jointDescIndex];
                if jointDesc.allowsLowering and self.attachedTool.aiNeedsLowering then
                    if jointDesc.moveAlpha == jointDesc.lowerAlpha then
                        return true;
                    else
                        self:setJointMoveDown(implement.jointDescIndex, true, true);
                        return false;
                    end
                end;
            end;
        else
            return false;
        end;
    end;
    if superFunc ~= nil then
        return superFunc(self);
    end
    return true;
end;

function vogelsangSwingMax30:getCanBeTurnedOn(superFunc)
    if self.attachedTool ~= nil then
        if self.attachedTool.isAlwaysTurnedOn and self.attachedTool.needsTankActivation and self.attachedTool.activateTankOnLowering then
            return false;
        end;
    end;
    if superFunc ~= nil then
        return superFunc(self);
    end
    return true;
end;

function vogelsangSwingMax30:getIsTurnedOnAllowed(superFunc, isTurnedOn)
    if isTurnedOn then
        if self.attachedTool == nil then
            local foldAnimTime = self.foldAnimTime;
            if foldAnimTime ~= nil and (foldAnimTime > self.manureBarrelFoldMaxLimit or foldAnimTime < self.manureBarrelFoldMinLimit) then
                return false;
            end;
        else
            if self.attachedTool:getIsInWorkPosition() then
                local implement = self:getImplementByObject(self.attachedTool);
                if implement ~= nil then
                    local jointDesc = self.attacherJoints[implement.jointDescIndex];
                    if jointDesc.allowsLowering and self.attachedTool.aiNeedsLowering then
                        return jointDesc.moveDown;
                    end;
                end;
            else
                return false;
            end;
        end;
    end;
    if superFunc ~= nil then
        return superFunc(self, isTurnedOn);
    end
    return true;
end;

function vogelsangSwingMax30:setIsTurnedOn(superFunc, isTurnedOn, noEventSend)
    superFunc(self, isTurnedOn, noEventSend);
end;

function vogelsangSwingMax30:onAiTurnOn()
    if self.attachedTool ~= nil then
        self.attachedTool:onAiTurnOn();
    end;
end;

function vogelsangSwingMax30:onAiTurnOff()
    if self.attachedTool ~= nil then
        self.attachedTool:onAiTurnOff();
    end;
end;

function vogelsangSwingMax30:onAiLower()
    if self.attachedTool ~= nil then
        local implement = self:getImplementByObject(self.attachedTool);
        if implement ~= nil then
            local jointDesc = self.attacherJoints[implement.jointDescIndex];
            if jointDesc.allowsLowering and self.attachedTool.aiNeedsLowering then
                if jointDesc.moveAlpha ~= jointDesc.lowerAlpha then
                    self:setJointMoveDown(implement.jointDescIndex, true, true);
                end;
            end;
        end;
    end;
end;

function vogelsangSwingMax30:onAiRaise()
    if self.attachedTool ~= nil then
        local implement = self:getImplementByObject(self.attachedTool);
        if implement ~= nil then
            local jointDesc = self.attacherJoints[implement.jointDescIndex];
            if jointDesc.allowsLowering and self.attachedTool.aiNeedsLowering then
                self:setJointMoveDown(implement.jointDescIndex, false, true);
            end;
        end;
    end;
end;

function vogelsangSwingMax30:getIsAIReadyForWork()
    local isReady = true;
    if self.attachedTool ~= nil then
        local implement = self:getImplementByObject(self.attachedTool);
        local jointDesc = self.attacherJoints[implement.jointDescIndex];
        if jointDesc.allowsLowering and self.attachedTool.aiNeedsLowering then
            if jointDesc.moveDown then
                return jointDesc.moveAlpha == jointDesc.lowerAlpha;
            else
                self:setJointMoveDown(implement.jointDescIndex, true, false);
                return false;
            end
        else
            return isReady;
        end
    end
    return isReady;
end

function vogelsangSwingMax30:groundAdjustRaycastCallback(transformId, x, y, z, distance)
    self.lastRaycastDistance = distance;
end;

function vogelsangSwingMax30:delete()
end;

function vogelsangSwingMax30:keyEvent(unicode, sym, modifier, isDown)
end;

function vogelsangSwingMax30:mouseEvent(posX, posY, isDown, isUp, button)
end;
